// YtvEditGridDial.cpp : implementation file
//

#include "stdafx.h"
#include "YtvEditGridDial.h"
#include "MSFLEXGRID.H"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// YtvEditGridDial dialog
const char g_szWM_YTV_EditGrid[]="WM_YTV_EditGrid";
DWORD g_uWM_YTV_EditGrid=RegisterWindowMessage((const char *)g_szWM_YTV_EditGrid);

YtvEditGridDial::YtvEditGridDial(): CDialog()
{
	//{{AFX_DATA_INIT(YtvEditGridDial)
	m_strEdit = _T("");
	//}}AFX_DATA_INIT
	m_pfgrid=NULL;
	m_col=-1;
	m_row=-1;
	m_nGridId=-1;
	m_pgridAL=NULL;
	m_pgridAC=NULL;
	m_hw=NULL;
	m_hwc=NULL;
}


void YtvEditGridDial::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(YtvEditGridDial)
	DDX_Control(pDX, IDC_YTVEDITGRID, m_edInp);
	DDX_Text(pDX, IDC_YTVEDITGRID, m_strEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(YtvEditGridDial, CDialog)
	//{{AFX_MSG_MAP(YtvEditGridDial)
	ON_EN_CHANGE(IDC_YTVEDITGRID, OnChangeYtveditgrid)
	ON_EN_KILLFOCUS(IDC_YTVEDITGRID, OnKillfocusYtveditgrid)
	ON_EN_SETFOCUS(IDC_YTVEDITGRID, OnSetfocusYtveditgrid)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// YtvEditGridDial message handlers
BOOL YtvEditGridDial::SetGrid()
{
    double ACD,A_C,SF,K1,K2;
	CString Temp;
	BOOL b;
        K1=atof(m_pgridAL->GetTextMatrix(1,1));
		K2=atof(m_pgridAL->GetTextMatrix(2,1));
		if(K1<35.0 || K2<35.0|| K1>60.0 ||K2>60.0)
		{
            m_pgridAL->SetTextMatrix(3,1,"0.0");           
			b=FALSE;
        }
		else
        {
			Temp.Format("%6.2f",(K1+K2)*0.5);
		    Temp.TrimLeft();
            m_pgridAL->SetTextMatrix(3,1,Temp);
            Temp.Format("%6.2f",K1);
		    Temp.TrimLeft();
            m_pgridAL->SetTextMatrix(1,1,Temp);
			Temp.Format("%6.2f",K2);
		    Temp.TrimLeft();
            m_pgridAL->SetTextMatrix(2,1,Temp);
		}
		Temp=m_pgridAC->GetTextMatrix(0,1);
        Temp.TrimLeft();
		A_C=atof(Temp);
		if(Temp.IsEmpty() || A_C<110.0 || A_C>130.0)
        {
           Temp=m_pgridAC->GetTextMatrix(1,1);
           Temp.TrimLeft();
		   ACD=atof(Temp);
		   if(ACD<1.0 || ACD>6.0)
           {
              m_pgridAC->SetTextMatrix(1,1,"0.00");
              m_pgridAC->SetTextMatrix(0,1,"000.0");
			  m_pgridAC->SetTextMatrix(2,1,"0.00");
			  b=FALSE;
           }
		   else
           {
		      SF=SfFromAcd(ACD);			 
              Temp.Format("%1.2f",SF);
			  Temp.TrimLeft();
              m_pgridAC->SetTextMatrix(2,1,Temp);
              Temp.Format("%1.2f",ACD);
			  Temp.TrimLeft();
              m_pgridAC->SetTextMatrix(1,1,Temp);
			  A_C=AConstFromSF(SF);
              Temp.Format("%3.1f",A_C);
			  Temp.TrimLeft();
              m_pgridAC->SetTextMatrix(0,1,Temp);
           }
        }
		else
        {
           SF=SfFromAConst(A_C);
           Temp.Format("%1.2f",SF);
		   Temp.TrimLeft();
           m_pgridAC->SetTextMatrix(2,1,Temp);
           Temp.Format("%3.1f",A_C);
		   Temp.TrimLeft();
           m_pgridAC->SetTextMatrix(0,1,Temp);
		   ACD=AcdFromSF(SF);
           Temp.Format("%1.2f",ACD);
		   Temp.TrimLeft();
           m_pgridAC->SetTextMatrix(1,1,Temp);
        }
		m_pgridAC->SetColSel(0);
		m_pgridAL->SetColSel(0);
		return b && TRUE;
		
    
}
void YtvEditGridDial::OnChangeYtveditgrid() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	double ACD,A_C,SF,K1,K2,AL,Rx;
	CString Temp;
	UpdateData();
	if(m_pfgrid==NULL)
	{
		ShowWindow(SW_HIDE);
		return;
    }
    if(m_col<1)
	{	
		SetGrid();
		ShowWindow(SW_HIDE);
		m_pfgrid->SetColSel(0);
		m_pfgrid=NULL;
		return;
    }
    if(m_row<0)
	{
		SetGrid();
		ShowWindow(SW_HIDE);
		m_pfgrid->SetColSel(0);
		m_pfgrid=NULL;
		return;
    }
	if(m_col>=m_pfgrid->GetCols())
	{
		SetGrid();
		ShowWindow(SW_HIDE);
		m_pfgrid->SetColSel(0);
		m_pfgrid=NULL;
		return;
    }
	if(m_row>=m_pfgrid->GetRows())
	{
		SetGrid();
		ShowWindow(SW_HIDE);
		m_pfgrid->SetColSel(0);
		m_pfgrid=NULL;
		return;  
	}	
	if(m_nGridId==1)
    {
       if(m_row==0)
       {
        Temp=m_strEdit;
        Temp.TrimLeft();
		A_C=atof(Temp);
		if(A_C==0.0)
        {
          m_pfgrid->SetTextMatrix(0,1,"");
          m_pfgrid->SetTextMatrix(1,1,"");
          m_pfgrid->SetTextMatrix(2,1,"");
        }
		else if(A_C>=110.0 && A_C<=130.0)
        {  
          SF=SfFromAConst(A_C);
          Temp.Format("%1.2f",SF);
		  Temp.TrimLeft();
          m_pfgrid->SetTextMatrix(2,1,Temp);
          Temp.Format("%3.1f",A_C);
		  Temp.TrimLeft();
          m_pfgrid->SetTextMatrix(0,1,Temp);
		  ACD=AcdFromSF(SF);
          Temp.Format("%1.2f",ACD);
		  Temp.TrimLeft();
          m_pfgrid->SetTextMatrix(1,1,Temp);
		  OnKillfocusYtveditgrid(); 
		}
       }
	   else if(m_row==1)
       {
           Temp=m_strEdit;;
           Temp.TrimLeft();
		   ACD=atof(Temp);
		   if(ACD>=1.0 && ACD<=6.0)
		   {
		    SF=SfFromAcd(ACD);			 
            Temp.Format("%1.2f",SF);
		    Temp.TrimLeft();
            m_pfgrid->SetTextMatrix(2,1,Temp);
            Temp.Format("%1.2f",ACD);
		    Temp.TrimLeft();
            m_pfgrid->SetTextMatrix(1,1,Temp);
		    A_C=AConstFromSF(SF);
            Temp.Format("%3.1f",A_C);
		    Temp.TrimLeft();
            m_pfgrid->SetTextMatrix(0,1,Temp);
			OnKillfocusYtveditgrid(); 
		   }
       }
	   else if(m_row==3)
       {
           Temp=m_strEdit;;
           Temp.TrimLeft();
		   Rx=atof(Temp);
		   //if(Rx>=-10.0 && Rx<=10.0)
		   //{
			   m_pfgrid->SetTextMatrix(3,1,Temp);
		       OnKillfocusYtveditgrid();
		   //}
		   
       }
    }
	else if(m_nGridId==0)
    {
       if(m_row==1)
	   { 
        m_strEdit.TrimLeft();
       	K1=atof(m_strEdit);
		K2=atof(m_pfgrid->GetTextMatrix(2,1));
		if(K1>=35.0 && K1<=60.0)
		{
          Temp.Format("%6.2f",(K1+K2)*0.5);
		  Temp.TrimLeft();
          m_pfgrid->SetTextMatrix(3,1,Temp);
          Temp.Format("%6.2f",K1);
		  Temp.TrimLeft();
          m_pfgrid->SetTextMatrix(1,1,Temp);
		  OnKillfocusYtveditgrid(); 
		}   
	   }
	   else if(m_row==2)
	   { 
        m_strEdit.TrimLeft();
       	K1=atof(m_pfgrid->GetTextMatrix(1,1));
		K2=atof(m_strEdit);
		if(K2>=35.0 && K2<=60.0)
		{
          Temp.Format("%6.2f",(K1+K2)*0.5);
		  Temp.TrimLeft();
          m_pfgrid->SetTextMatrix(3,1,Temp);
		  Temp.Format("%6.2f",K2);
		  Temp.TrimLeft();
          m_pfgrid->SetTextMatrix(2,1,Temp);
		  UpdateData(FALSE);
		}  
	   }
	   else if(m_row==0)
       {
          m_strEdit.TrimLeft();
          AL=atof(m_strEdit);
          if(AL>=15.0 && AL<=40.0)
          {
            Temp.Format("%6.2f",AL);
		    Temp.TrimLeft();
            m_pfgrid->SetTextMatrix(0,1,Temp);
			OnKillfocusYtveditgrid(); 
          }
       }
    }
	else
      	SetGrid();
	//ed=atof(m_strEdit);
	//m_pfgrid->SetTextMatrix(m_row,m_col,m_strEdit);

	UpdateData(FALSE);
}

void YtvEditGridDial::OnKillfocusYtveditgrid() 
{
	// TODO: Add your control notification handler code here
	if(IsWindow(m_hw))
		::PostMessage(m_hw,g_uWM_YTV_EditGrid,MAKELONG(IDC_CALCULATE,1),(LPARAM)m_hwc);
}

void YtvEditGridDial::OnSetfocusYtveditgrid() 
{
	// TODO: Add your control notification handler code here
	SetData(NULL);
}

BOOL YtvEditGridDial::Create(HWND hParentWnd) 
{
	// TODO: Add your specialized code here and/or call the base class
	m_hParent=hParentWnd;
	return CDialog::Create(IDD, CWnd::FromHandle(hParentWnd));
}

void YtvEditGridDial::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	RECT rt;
	rt.top=rt.left=0;
	rt.bottom=cy;
	rt.right=cx;
	if(!IsWindow(m_edInp.m_hWnd))
		return;
	m_edInp.MoveWindow(&rt);
	// TODO: Add your message handler code here
	
}
const char* YtvEditGridDial::SetData(char* pd)
{
	UpdateData();
	m_strEdit.Empty();
    if(pd)
      m_strEdit=pd;
	else
    {
    if(m_pfgrid==NULL)
		return m_strEdit;
    if(m_col<1)
		return m_strEdit;
    if(m_row<0)
		return m_strEdit;
	if(m_col>=m_pfgrid->GetCols())
		return m_strEdit;
	if(m_row>=m_pfgrid->GetRows())
		return m_strEdit;
    m_strEdit=m_pfgrid->GetTextMatrix(m_row,m_col);
    m_edInp.SetWindowText(m_strEdit);
    }
	UpdateData(FALSE);
    m_edInp.SetFocus();
	return m_strEdit;
}
