// YtvScansView.h : interface of the CYtvScansView class
//
/////////////////////////////////////////////////////////////////////////////
//{{AFX_INCLUDES()
#include "mscomm.h"
//}}AFX_INCLUDES

#if !defined(AFX_YTVULTRASOUNDMEDSCAN0VIEW_H__06B38DAC_4709_4985_9E13_34D917DA522B__INCLUDED_)
#define AFX_YTVULTRASOUNDMEDSCAN0VIEW_H__06B38DAC_4709_4985_9E13_34D917DA522B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CYtvScansDoc;
class CYtvPropertySheet;
class MeasurementPage;
class CCalculatorPage;
class DataBasePage;
class ExitPage;
class PrintPage;
class CYtvScansView :  public CFormView
{
protected: // create from serialization only
	CYtvScansView();
	DECLARE_DYNCREATE(CYtvScansView)

public:
	BOOL m_bSizedBefore;
	HWND m_hWndFocus;
	CYtvPropertySheet* m_pPropSheet;
	DataBasePage*    m_prpDataBasePage;
	MeasurementPage* m_prpMesurePage;
	CCalculatorPage* m_prpCalcPage;
	PrintPage*       m_prpPrintPage;
	ExitPage*        m_prpExitPage;
	CPrintInfo* m_pInfo;
	afx_msg void OnDbName();
	//{{AFX_DATA(CYtvScansView)
	enum { IDD = IDD_YTVULTRASOUNDMEDSCAN0_FORM };
	//}}AFX_DATA

// Attributes

public:

	CYtvScansDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CYtvScansView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnDraw(CDC* pDC);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CYtvScansView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CYtvScansView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnClose();
	afx_msg void OnYtvNextSlide();
	afx_msg void OnYtvPreviousSlide();
	afx_msg void OnYtvExpandCursors();
	afx_msg void OnYtvMoveLeftCursors();
	afx_msg void OnYtvMoveRightCursors();
	afx_msg void OnYtvCompressCursors();
	afx_msg void OnYtvHelp0();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in YtvScansView.cpp
inline CYtvScansDoc* CYtvScansView::GetDocument()
   { return (CYtvScansDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_YTVULTRASOUNDMEDSCAN0VIEW_H__06B38DAC_4709_4985_9E13_34D917DA522B__INCLUDED_)
