//{{AFX_INCLUDES()

//}}AFX_INCLUDES
#if !defined(AFX_MEASUREMENTPAGE_H__6669E025_4761_4A70_8032_60347A288A4E__INCLUDED_)
#define AFX_MEASUREMENTPAGE_H__6669E025_4761_4A70_8032_60347A288A4E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MeasurementPage.h : header file
//
//#include "../../YtvDlls/YtvAfxUltrasoundDll/YtvStatic.h"
#include "mscomm.h"
/////////////////////////////////////////////////////////////////////////////
// MeasurementPage dialog
class MeasurementPage : public CPropertyPage
{
	DECLARE_DYNCREATE(MeasurementPage)

// Construction
public:
	MeasurementPage();
	~MeasurementPage();
static	BOOL m_bSimulateInput;
    void SetInit();
	void InitAutoAndSemiVisualState();	
	void InitDateSetting();
	void SetAverages();
	int SetPageImageState(BOOL bWipeInput);
	void WipeInputAndOutput(BOOL WipeInput=TRUE);
	void SetGatesColor();
	void VisualSetGates();
	BOOL Invert();
	int GetSetCurrentScanFromGroup();
	void ComputeAutoParameters();
	void RecordScan(int index=-1,int ModeAMV=-2);
	void PlayScan(BOOL bin=FALSE,BOOL PlayInsideGroupOnly=TRUE);
	int WriteRegSession();
	int ReadRegSession(BOOL bWipeInput);
	int ReadRegAllSessions();
	void MoveGates();
	void DisplayGraph();
	void SetCornia();
	void KillTimers();
	int ContinueTimers();
	void DeleteScan(int scn);
	void DrawMarks(unsigned int MakeSound=1);
	int DataMeasure();
	int CheckManual();
	int CheckAphacicImmersion();
    int CheckCataractImmersion();
    int CheckAphacicContact();
	int CheckCataractContact();
	void CalculateAvSd();
	BOOL m_bInitDateSetting;
	int m_nSel;
	CFont m_font;
	CString m_strSessionStatAverages;
   CString m_strAddionalRegistryOld;
   void InitSimulateECPDataRead(int count=0);
   int SimulateECPDataRead(int* m_npDataBuf, int m_nMemorySize, BOOL bAllRandom);
    static	enum entypeRegistryNodes  m_enTypeRegNode;
    static char* m_pszPatientRecFormat[];
	static char* m_pszDoctorRecFormat[];
	static char* m_pszLensTypeRecFormat[];
	static char* m_pszFullPatientRecFormat[];
	static char* m_pszFullDoctorRecFormat[];
	static char* m_pszFullLensTypeRecFormat[];
	static char* m_pszEditNewLensTypeRecFormat[];
	static char* m_pszMeasureHistoryTypeRecFormat[];
	static char* m_pszCalculatorTypeRecFormat[];
		//static char* m_pszPrintTypeRecFormat[];
	//static char* m_pszScansTypeRecFormat[];
	static struct sttypeRegistryNodes m_arListReg[];
	CString m_szTodayDate;
	CString m_szReadDate;
	CString m_szTodayTime;
	int m_nNextScan;
	int m_nCurrentScan;
	int m_nGlobalScanGroup;
	int m_nCurrentScanGroup;
	int m_nModeAMV;
	int m_nDBFilter;
	int m_nDBCataract;
	int m_nDBContact;
	int m_nDBCurrentScanGroup;
	BOOL m_bDisplay;
   BOOL m_bOD;
   class ScanGroups
   {
   public:
	   int nAuto;
       int nDBFilter;
	   int nDBCataract;
	   int nDBContact;
	   int nDBScanBegId;
	   int nDBScanLastId;
   }m_stScanGroups;
   CArray<ScanGroups, ScanGroups&>m_arScanGroups;
   class ThreshHolds
   {
	  public:
      unsigned Pics[5];	
	  //Fifth is DB Id
   }m_curThr,m_delThr;
   CArray<ThreshHolds, ThreshHolds&>m_arThreshHolds;
// Dialog Data
	//{{AFX_DATA(MeasurementPage)
	enum { IDD = IDD_MEASUAREMENT };
	CButton	m_btMeassure;
	CStatic	m_staScG;
	CStatic	m_staSetDate;
	CComboBox	m_comboSetDate;
	CSpinButtonCtrl	m_spinScG;
	CEdit	m_edScanGroup;
	CButton	m_chkNoAutoFreeze;
	CStatic	m_edAver;
	CButton	m_checkManualSemiAuto;
	CEdit	m_edMaxCadrNum;
	CEdit	m_edSlideCount;
	CStatic	m_staVelo;
	CButton	m_chkSave;
	CButton	m_btContact;
	CButton	m_btImmersion;
	CButton	m_btCataract;
	CButton	m_btApracic;
	CStatic m_ctrlBottomLeft;
	CStatic m_ctrlLens;
	CStatic m_ctrlRetina;
	CButton	m_ctrlPlay;
	CButton	m_ctrlStop;
	CButton	m_ctrlFirst;
	CButton	m_ctrlLast;
	CButton	m_ctrlPrevious;
	CButton	m_ctrlRecord;
	CButton	m_ctrlNext;
	CButton	m_btFreeze;
	CButton	m_btOdOs;
	int		m_nAuto;
	int		m_nCataract;
	int		m_nContact;
	CMSFlexGrid	m_gridAxis;
	CMSFlexGrid	m_gridPatient;
	CMSFlexGrid	m_gridSquares;
	CString	m_stAver;
	CString	m_stLens;
	CString	m_stAvelo;
	CString	m_stavelo2;
	CString	m_stavelo3;
	CString	m_stavelo4;
	CString	m_stavelo5;
	CString	m_stbottomleft;
	CString	m_stRetina;
	BOOL	m_bMeassureButton;
	CYtvGraphCtrl	m_imGraph;
	BOOL	m_bFreeze;
	CMSComm	m_commPortCtrl;
	CMSFlexGrid	m_gridMaAvSd;
	int		m_nPlay;
	BOOL	m_bSave;
	CString	m_strSlideCount;
	CString	m_strMuxCadrNum;
	BOOL	m_bFilterNotInManualMode;
	CString	m_strGroupScan;
	BOOL	m_bNoAutoFreeze;
	CString	m_szSetDate;
	//}}AFX_DATA
	CString m_strFormat;
	int m_nLastSelectedAvDist;
	double m_dDistance;
	double m_dPrevAl;
	BOOL m_bSecondGate;
	unsigned m_uPrevScanNumber;
	int m_nCurIDEvent;
	double   m_dImmersionWidth;
	double   m_dCurrentCorniaGateWidth;
	double   m_dLensWidth;
	double   m_dRetinaWidth;
	double   m_dLensGateWidth;
	double   m_dRetinaGateWidth;
	unsigned m_uGate0begin;
	unsigned m_uGate0end;
	unsigned m_uGate2begin;
	unsigned m_uGate1begin;
	unsigned m_uGate2end;
	unsigned m_uGate1end;
	int m_PrevNumbPics[4];
	int m_NumbPics[4];
  	double m_dVelocityCoef[4];
	int m_nMaxRetina;//=(int)(255.0*0.98+0.5);//?
	int m_nPick;//=(int)(255.0*0.90+0.5);?
    int m_nThreshHold;//=(int)(65.0*1.0+0.5);
	int m_nMinComp;
	int m_nRetinaGate;
	int m_nLensGateBeginMem;
	int m_nLensGateEndMem;
	int m_nCorniaGateBegin;
	int m_nCorniaGateEndMem;
	int m_nPrevScanNumber;
	double m_dAL;//=(m_NumbPics[encRetinaThreshHold]-m_NumbPics[encCorniaThreshHold])*0.03875;
    double m_dACD;//=(m_NumbPics[encLensThreshHoldBegin]-m_NumbPics[encCorniaThreshHold])*0.03835;
    double m_dLT;//=(m_NumbPics[encLensThreshHoldEnd]-m_NumbPics[encLensThreshHoldBegin])*0.041;
    double m_dVIT;
	int m_nLastSelectedScanNumber;
	int m_nGlobalSessionLastScanNumber;
	double m_dTotalAL;
	double m_dALSD;
	void EmptyGrids();
    HBITMAP m_hbm;
	HBRUSH   m_hbrTempBrush;
	HBRUSH   m_hbrDialBrush;
	HBRUSH   m_hbrGraphBrush;
	COLORREF m_clrGraphBrush;
	COLORREF m_clrDialBrush;
	COLORREF m_clrDialBack;
	COLORREF m_clrDialFront;
	HBRUSH   m_hbrButtonsBrush;
    COLORREF m_clrButtonsBrush; 
	COLORREF m_clrButtonsBack;
	COLORREF m_clrButtonsFront;
	HBRUSH   m_hbrStaticBrush;
    COLORREF m_clrStaticBrush; 
	COLORREF m_clrStaticBack;
	COLORREF m_clrStaticFront;
	COLORREF m_clrMsgBoxesBrush; 
	HBRUSH   m_hbrMsgBoxesBrush;
	COLORREF m_clrMsgBoxesBack;
	COLORREF m_clrMsgBoxesFront;
	COLORREF m_clrEditBoxesBrush; 
	HBRUSH   m_hbrEditBoxesBrush;
	COLORREF m_clrEditBoxesBack;
	COLORREF m_clrEditBoxesFront;
	COLORREF m_clrScrollBarsBrush; 
	HBRUSH   m_hbrScrollBarsBrush;
	COLORREF m_clrScrollBarsBack;
	COLORREF m_clrScrollBarsFront;
	COLORREF m_clrListBoxesBrush; 
	HBRUSH   m_hbrListBoxesBrush;
	COLORREF m_clrListBoxesBack;
	COLORREF m_clrListBoxesFront;
	////////////////////////////////
	COLORREF m_clrStRetinaFront;
	COLORREF m_clrStRetinaBack;
    HBRUSH   m_hbrStRetinaBrush;
	HBRUSH   m_hbrStAltRetinaBrush;
	COLORREF m_clrStLensFront;
	COLORREF m_clrStLensBack;
	HBRUSH   m_hbrStLensBrush;
	HBRUSH   m_hbrStAltLensBrush;
	COLORREF m_clrStRetinaFrontInit;
	COLORREF m_clrStRetinaBackInit;
    HBRUSH   m_hbrStRetinaBrushInit;
	HBRUSH   m_hbrStAltRetinaBrushInit;
	COLORREF m_clrStLensFrontInit;
	COLORREF m_clrStLensBackInit;
	HBRUSH   m_hbrStLensBrushInit;
	HBRUSH   m_hbrStAltLensBrushInit;
	/////////////////////////////
	COLORREF m_clrStGate0Front;
	COLORREF m_clrStGate0Back;
	HBRUSH   m_hbrStGate0Brush;
	void SetComPort();
    int GetComPort();
	int m_nComPortNo;
	BOOL m_bPortDetected;
	BOOL m_bPortOpenStatus;
	int m_nMemorySize;
	short int m_nNegotiateValue;
	double m_dVMultifactor;
	double m_dHMultifactor;
	BOOL m_bAphakicSelected;//Reassign for button
	DWORD m_nManualMeasureCount;
	DWORD m_nManPlayLastPosition;
	BOOL m_bManualCont_Flag;
    int m_nManualCont_Count;
	int m_nAxialLength;
	int m_bContactModeSelected;
    int m_nLensOnePosition_ContactMode;
	int m_nLensEndPosition;
	int m_nLensEndPosition_ContactMode;
    int m_nRetinaPosition_ContactMode;
    BOOL m_bImmersionModeSelected;
	int m_nRetinaPosition_ImmersionMode;
	int m_nLensOnePosition_ImmersionMode;
	int m_nLensEndPosition_ImmersionMode;
	int m_nCorneaEndPosition_ImmersionMode;
	BOOL m_bStop;
	double fManualVelocity;
	int m_nAutoRetinaPosition;
	int m_nTempPosition;
	int m_nVPos;
	int m_nHPos;
	int m_nCorneaStartPosition_ImmersionMode;
	int m_bCataractSelected;
	BOOL m_bManualMeasure;
    CString m_strQueryPatientID;
//////////////////////////////////////////
	CString	m_szDoctorId;
	CString	m_szPatient_Id;
	CString	m_szFirstname;
	CString	m_szLastname;
	CString	m_szP_Address;
	CString	m_szP_city;
	CString	m_szP_zip;
	CString	m_szK_value_l;
	CString	m_szK_value_r;
	CString	m_szK1_value_l;
	CString	m_szK1_value_r;
	CString	m_szK2_value_l;
	CString	m_szK2_value_r;
	CString	m_szP_age;
	CString	m_szDob_mm;
	CString	m_szDob_yy;
	CString	m_szDob_dd;
	CString	m_szNote;
	CString	m_szDoctorName;
	int		m_nGender;
	CString	m_szP_phone;
	CString	m_szP_state;
//////////////////////////////////////////	
	int *m_npDataBuf;
	int ReadRegDB();
	void GetData();
	afx_msg LRESULT YtvOnStatic(WPARAM wp, LPARAM lp);
// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(MeasurementPage)
	public:
	virtual BOOL OnKillActive();
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
public:
	// Generated message map functions
	//{{AFX_MSG(MeasurementPage)
	virtual BOOL OnInitDialog();
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnMeasure();
	afx_msg void OnOnCommMscommreaddata();
	afx_msg void OnClose();
	afx_msg void OnReadyStateChangeYtvgraphctrl();
	afx_msg void OnFreez();
	afx_msg void OnMsCommMeasEv();
	afx_msg void OnAuto();
	afx_msg void OnRecord();
	afx_msg void OnPrevious();
	afx_msg void OnPlay();
	afx_msg void OnNext();
	afx_msg void OnFirst();
	afx_msg void OnLast();
	afx_msg void OnStopRecordind();
	afx_msg void OnOdOs();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnManual();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDelete();
	afx_msg void OnDisplay();
	afx_msg void OnYtvNextSlide();
	afx_msg void OnYtvPreviousSlide();
	afx_msg void OnSave();
	afx_msg void OnStretina();
	afx_msg void OnStlens();
	afx_msg void OnYtvCompressCursors();
	afx_msg void OnYtvExpandCursors();
	afx_msg void OnYtvMoveLeftCursors();
	afx_msg void OnYtvMoveRightCursors();
	afx_msg void OnFilterAuto();
	afx_msg void OnImmersion();
	afx_msg void OnContact();
	afx_msg void OnCataract();
	afx_msg void OnAphakic();
	afx_msg void OnSelChangeGridSquares();
	afx_msg void OnChangeEditgroupScan();
	afx_msg void OnUpdateEditgroupScan();
	afx_msg void OnDeltaposScangroupspin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeComboSetdate();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MEASUREMENTPAGE_H__6669E025_4761_4A70_8032_60347A288A4E__INCLUDED_)
